unit CPL;

{
  Win32 Control Panel Extensions. Windows.pas didn't include
  this, so the authors created it for readers of Delphi Secrets.
}

interface
uses
  Windows, Messages;

const

  WM_CPL_LAUNCH = WM_USER + 1000;
  WM_CPL_LAUNCHED = WM_USER + 1001;

  { Message }
  CPL_DYNAMIC_RES = 0;
  CPL_INIT = 1;
  CPL_GETCOUNT = 2;
  CPL_INQUIRE = 3;
  CPL_SELECT = 4;
  CPL_DBLCLK = 5;
  CPL_STOP = 6;
  CPL_EXIT = 7;
  CPL_NEWINQUIRE = 8;
  CPL_STARTWPARMS = 9;
  CPL_SETUP = 200;

type

TPCPLInfo = ^TCPLInfo;
TCPLInfo = record
  idIcon: Integer;
  idName: Integer;
  idInfo: Integer;
  lData: Pointer;
end;

TPNewCPLInfo = ^TNewCPLInfo;
TNewCPLInfo = record
  dwSize: DWORD;
  dwFlags: DWORD;
  dwHelpContext: DWORD;
  lData: Pointer;
  Icon: HICON;
  szName: array[0..31] of char;
  szInfo: array[0..63] of char;
  szHelpFile: array[0..127] of char;
end;

TCPlApplet = function (hwndCPL: HWND; uMsg: UINT;
  lParam1: LPARAM; lParam2: LPARAM) : LongInt; stdcall;


implementation

end.
