unit installu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    imgKnight: TImage;
    Timer: TTimer;
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
    { Private declarations }
    FSysDir: string;
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

const
  step_x: Integer = 10;
  step_y: Integer = 10;
  
  {$R *.DFM}
  
procedure TMainForm.FormPaint(Sender: TObject);
const
  Level: Integer = 200; // Xh
var
  I, Step: Integer;
begin
  Step := ClientHeight div Level + 1; // CXu
  
  for I := 0 to ClientHeight - 1 do
  begin
    Canvas.Pen.Color := RGB(I div Step mod Level,
      I div Step mod Level, 150); // ŦTw, , vW

    // q̥e̥k䪺u
    Canvas.MoveTO(0, I);
    Canvas.LineTo(ClientWidth, I);
  end;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Invalidate;
end;



procedure MsgBox(const Msg: string);
begin
  Application.MESSAGEBOX(PChar(Msg), PChar(Application.Title), MB_ICONINFORMATION);
end;

procedure ErrBox(const Msg: string);
begin
  Application.MESSAGEBOX(PChar(Msg), PChar(Application.Title), MB_ICONERROR);
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
  Buf: array[0..255] of Char;
begin
  GetSystemDirectory(Buf, 255);
  FSysDir := StrPas(Buf);
  if FSysDir[Length(FSysDir)] <> '\' then AppendStr(FSysDir, '\');
  
  
  imgKnight.Left := Random(ClientWidth) - imgKnight.Width;
  imgKnight.Top := Random(ClientHeight) - imgKnight.Height;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
const
  Sources: array[0..2] of string = ('xmtucfg.cpl', 'xmtucfg.hlp', 'xmtucfg.cnt');
var
  I: Integer;
begin
  for I := 0 to 2 do
    if not FileExists(Sources[I]) then
    begin
      ErrBox('䤣lɮ: ' + Sources[I] + ', w˥ !!');
      Exit;
    end;
  
  for I := 0 to 2 do
    CopyFile(PChar(Sources[I]), PChar(FSysDir + Sources[I]), False);
  
  MsgBox('w˧ !! Ynϥ, Х}x, 䤤 XMTUCfg  !!');
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
  DeleteFile(FSysDir + 'xmtucfg.cpl');
  DeleteFile(FSysDir + 'xmtucfg.hlp');
  DeleteFile(FSysDir + 'xmtucfg.cnt');
  DeleteFile(FSysDir + 'xmtucfg.gid');
  MsgBox('\ XMTUCfg, ±z !!');
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
begin
  CLOSE;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
  imgKnight.Left := imgKnight.Left + step_x;
  imgKnight.Top := imgKnight.Top + step_y;
  
  if (imgKnight.Left < 0) or (imgKnight.Left + imgKnight.Width >= ClientWidth) then step_x := - step_x;
  if (imgKnight.Top < 0) or (imgKnight.Top + imgKnight.Height >= ClientHeight) then step_y := - step_y;
  
  if Random(10) > 5 then inc(step_x) else dec(step_x);
  if Random(10) > 5 then inc(step_y) else dec(step_y);
end;

procedure TMainForm.FormDblClick(Sender: TObject);
begin
  Timer.Enabled := not Timer.Enabled;
end;

initialization
  Randomize;
end.

