library xmtucfg;

uses
  Windows,
  SysUtils,
  Dialogs,
  CPL,
  Forms,
  main in 'main.pas' {MainForm},
  util in 'util.pas';

{$R *.RES}
{$R icon.res}

function CPlApplet(hwndCPL: HWND; uMsg: UINT;
  lParam1: LPARAM; lParam2: LPARAM) : LongInt; stdcall;
var
  pInfo: PCPlInfo;
  pNewInfo: PNewCPlInfo;
begin
  case uMsg of
    CPL_INIT:
    begin
      Result := 1;
    end;

    CPL_GETCOUNT:
    begin
      Result := 1;
    end;

    CPL_INQUIRE:
    begin
      pInfo := PCPlInfo(lParam2);

      with pInfo^ do begin
        idName := CPL_DYNAMIC_RES;
        idInfo := CPL_DYNAMIC_RES;
        idIcon := CPL_DYNAMIC_RES;
        lData := 0;
      end;
    end;

    CPL_NEWINQUIRE:
    begin

      pNewInfo := PNewCPlInfo(lParam2);

      with pNewInfo^ do begin
        dwSize := sizeof(TNewCPLInfo);
        dwFlags := 0;
        dwHelpContext := 0;
        hIcon := LoadIcon(hInstance, 'Knight');
        StrPLCopy(szName, 'XMTUCfg', 31);
        StrPLCopy(szInfo, 'ק MTU  RWIN ]w', 63);
        StrPLCopy(szHelpFile, 'xmtucfg.hlp', 127);
        lData := 0;
      end;
    end;

    CPL_DBLCLK:
    begin
      with TMainForm.Create(Application) do
      begin
        ShowModal;
        Free;
      end;

      Result := 0;  // success
    end;

    CPL_STOP:
    begin
      Result := 0;  // sent once per application before CPL_EXIT
    end;

    CPL_EXIT:
    begin
      Result := 0;  // sent once before FreeLibrary is called
    end;
  end;
end;

exports
  CPlApplet;

begin
end.

