unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, MMSystem;

type
  TForm1 = class(TForm)
    rgpTimerType: TRadioGroup;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    txtInterval: TEdit;
    Label1: TLabel;
    txtStopCount: TEdit;
    lblElapsed: TLabel;
    lblCount: TLabel;
    lblError: TLabel;
    btnStart: TButton;
    btnStop: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMTimer(var message: TWMTimer); message WM_TIMER;
    procedure CommonTimerProc;
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;
  
implementation

{$R *.DFM}

const
  TimerInterval: DWORD = 10; { w]jɶ 10 @ }
  
var
  MMTimerID   : Integer; { xs MMTimer  ID }
  StartTime   : DWORD;   { Ұʭpɾɥ GetTickCount oɶ }
  TriggerCount: DWORD;   { Ĳo }
  StopCount   : DWORD;   { Y 0, ĲoƨFȫ۰ʰ }
  
procedure TForm1.CommonTimerProc;
var
  TimeDiff: DWORD; { ڪOɶ }
begin
  { pڪOɶ }
  TimeDiff := GetTickCount - StartTime;
  lblElapsed.Caption := 'Time : ' + IntToStr(TimeDiff) + ' ms';
  
  { ֥[pƾ }
  Inc(TriggerCount);
  lblCount.Caption := 'Count: ' + IntToStr(TriggerCount) + ' times';
  
  { ~t = ڹڪOɶ - pƾ * jɶ }
  lblError.Caption := 'Error: ' + IntToStr(TimeDiff - TriggerCount *
    TimerInterval) + ' ms';
  
  if (StopCount <> 0) and (TriggerCount = StopCount) then
    btnStopClick(btnStop);
end;

procedure TimerProc(Window: HWND; message, idEvent: UINT; dwTime:
    DWORD); stdcall;
begin
  Form1.CommonTimerProc;
end;

procedure MMTimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2:
    DWORD); stdcall;
begin
  Form1.CommonTimerProc;
end;

procedure TForm1.WMTimer(var message: TWMTimer);
begin
  CommonTimerProc;
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  TimerInterval := StrToIntDef(txtInterval.Text, 10);
  StopCount := StrToIntDef(txtStopCount.Text, 0);
  
  rgpTimerType.Enabled := False;
  TriggerCount := 0;
  StartTime := GetTickCount;
  
  { ھڿܲͤPpɾ }
  case rgpTimerType.ItemIndex of
    0: SetTimer(Handle, 1, TimerInterval, nil);
    1: SetTimer(Handle, 1, TimerInterval, @TimerProc);
    2: MMTimerID := timeSetEvent(TimerInterval, 0, @MMTimerProc, 0,
      TIME_PERIODIC or TIME_CALLBACK_FUNCTION);
  end;
  
  btnStop.Enabled := True;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  case rgpTimerType.ItemIndex of
    0..1: KillTimer(Handle, 1);
    2: if MMTimerID <> 0 then timeKillEvent(MMTimerID);
  end;
  
  rgpTimerType.Enabled := True;
  btnStop.Enabled := False;
end;

end.

